// Create a global option of type VT_BSTR
var strGlobalVT_BSTR = "VT_BSTR";

// Create a global option of type VT_I4
var iGlobalVT_I4 = 255;

// Create a global option of type VT_BOOL
var bGlobalVT_BOOL = false;

// Create a global array of options of type VT_ARRAY
var objGlobalVT_ARRAY = ["First","Second","Third","",""];
//var objGlobalVT_ARRAY = new Array();
//objGlobalVT_ARRAY[0] = "First";
//objGlobalVT_ARRAY[1] = "Second";
//objGlobalVT_ARRAY[2] = "Third";
//objGlobalVT_ARRAY[3] = "";
//objGlobalVT_ARRAY[4] = "";


// Called by Directory Opus to initialize the script
function OnInit(initData)
{
   DOpus.OutputString("Initializing...");
   // Provide basic information about the Script
   initData.name = "ScriptCommand_test_jscript: ";
   initData.desc = "Adds the 'Test_Jscript' command to Directory Opus.";
   initData.copyright = "(c) 2014 steje";
   initData.version = "v1.0.0 (js)";
   initData.default_enable = true;

   // Initialise the command that this script adds
   var cmd = initData.AddCommand();
   cmd.name = "Test_Jscript";
   cmd.icon = "getsizes";
   cmd.method = "OnTest_Jscript";
   cmd.desc = "Test JScript - checks ScriptConfig properties against their default values...";
   cmd.label = "Test_Jscript";
   cmd.template = "STRING/O";

   // Set DEBUG flag below to true in order to enable logging messages to the Opus Output Window
   initData.config.DEBUG = true;

   //////////////////////////////////////////////////
   // Create a ScriptConfig property of type VT_BSTR
   initData.config.strScriptVT_BSTR = "VT_BSTR";

   //////////////////////////////////////////////////
   // Create a ScriptConfig property of type VT_I4
   initData.config.iScriptVT_I4 = 255;

   //////////////////////////////////////////////////
   // Create a ScriptConfig property of type VT_BOOL
   initData.config.bScriptVT_BOOL = false;

   //////////////////////////////////////////////////
   // Create a ScriptConfig property of type VT_ARRAY
   initData.config.objScriptVT_ARRAY = ["First","Second","Third","",""];
//   initData.config.objScriptVT_ARRAY = new Array();
//   initData.config.objScriptVT_ARRAY[0] = "First";
//   initData.config.objScriptVT_ARRAY[1] = "Second";
//   initData.config.objScriptVT_ARRAY[2] = "Third";
//   initData.config.objScriptVT_ARRAY[3] = "";
//   initData.config.objScriptVT_ARRAY[4] = "";

   DOpus.OutputString("ScriptConfig property objScriptVT_ARRAY is of type:  " + (typeof initData.config.objScriptVT_ARRAY));
   for (i =0; i < initData.config.objScriptVT_ARRAY.length; i++)
   {
      if (initData.config.objScriptVT_ARRAY[i] == objGlobalVT_ARRAY[i]) {
         DOpus.OutputString("ScriptConfig property objScriptVT_ARRAY values are set to:  [" + i + "]: DEFAULT -> " + initData.config.objScriptVT_ARRAY[i]);
      } else {
         DOpus.OutputString("ScriptConfig property objScriptVT_ARRAY values are set to:  [" + i + "]: CUSTOM -> " + initData.config.objScriptVT_ARRAY[i]);
      }
   }

   return false;
}


// Implement the Test_Jscript command
function OnTest_Jscript(commandData)
{
   var message = "";

   logMsg("");
   logMsg("------------Begin------------");

   //////////////////////////////////////////////////
   // Test the strScriptVT_BSTR ScriptConfig property
   logMsg("");
   message = "ScriptConfig property strScriptVT_BSTR is ";
   logMsg(message + "of type:  " + (typeof Script.config.strScriptVT_BSTR));
   if (Script.config.strScriptVT_BSTR === strGlobalVT_BSTR) {
      logMsg("" + message + "set to:  DEFAULT -> " + Script.config.strScriptVT_BSTR);
   } else {
      logMsg(message + "set to:  CUSTOM -> " + Script.config.strScriptVT_BSTR);
   }

   //////////////////////////////////////////////////
   // Test the iScriptVT_I4 ScriptConfig property
   logMsg("");
   message = "ScriptConfig property iScriptVT_I4 is ";
   logMsg(message + "of type:  " + (typeof Script.config.iScriptVT_I4));
   if (Script.config.iScriptVT_I4 === iGlobalVT_I4) {
      logMsg("" + message + "set to:  DEFAULT -> " + Script.config.iScriptVT_I4);
   } else {
      logMsg(message + "set to:  CUSTOM -> " + Script.config.iScriptVT_I4);
   }

   //////////////////////////////////////////////////
   // Test the bScriptVT_BOOL ScriptConfig property
   logMsg("");
   message = "ScriptConfig property bScriptVT_BOOL is ";
   logMsg(message + "of type:  " + (typeof Script.config.bScriptVT_BOOL));
   if (Script.config.bScriptVT_BOOL === bGlobalVT_BOOL) {
      logMsg("" + message + "set to:  DEFAULT -> " + Script.config.bScriptVT_BOOL);
   } else {
      logMsg(message + "set to:  CUSTOM -> " + Script.config.bScriptVT_BOOL);
   }

   //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
   //////////////////////////////////////////////////
   // Test the objScriptVT_ARRAY ScriptConfig property
   logMsg("");
   message = "ScriptConfig property objScriptVT_ARRAY ";
   logMsg("" + message + "is of type:  " + (typeof Script.config.objScriptVT_ARRAY));
//   logMsg("" + message + "is of type:  " + (Script.config.objScriptVT_ARRAY.getType));
   // How bad can I crash things...

   // throws a ('Script.config.objScriptVT_ARRAY.length' is null or not an object (0x800a138f)) error
//   for (i =0; i < Script.config.objScriptVT_ARRAY.length; i++)
//   {
//      if (Script.config.objScriptVT_ARRAY[i] == objGlobalVT_ARRAY[i]) {
//         logMsg(message + "values are set to:  [" + i + "]: DEFAULT");
//      } else {
//         logMsg(message + "values are set to:  [" + i + "]: CUSTOM");
//      }
//   }

   //////////////////////////////////////////////////
   // Test the objGlobalVT_ARRAY Global option
   logMsg("");
   message = "The Global option objGlobalVT_ARRAY ";
   logMsg("" + message + "is of type:  " + (typeof objGlobalVT_ARRAY));
   // but this is obviously fine on a recognized array object:
   for (i =0; i < objGlobalVT_ARRAY.length; i++)
   {
      if (objGlobalVT_ARRAY[i] == objGlobalVT_ARRAY[i]) {
         logMsg(message + "values are set to:  [" + i + "]: " + objGlobalVT_ARRAY[i]);
      } else {
         logMsg(message + "values are set to:  [" + i + "]: WTF HAPPENED HERE var != var ???");
      }
   }
   //////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////

   logMsg("");
   logMsg("-------------End-------------\n");

   return false;
}


// Had some weird results using typeof, found this on stackoverflow as a way to resolve deficiencies in typeof
Object.prototype.getType = function() {
   var funcNameRegex = /function (.{1,})\(/;
   var results = (funcNameRegex).exec((this).constructor.toString());
   return (results && results.length > 1) ? results[1] : "";
};


// Subroutine to allow toggling of the global VT_BOOL variable to control whether logging is performed or not
function logMsg(message)
{
   if (Script.config.DEBUG) DOpus.OutputString(message);

   return;
}
